package cn.com.infosec.mobile.android.framework.crypto;

import java.security.PublicKey;

public interface IHSM {
   String RSA = "RSA";
   String SM2 = "SM2";
   String SIGN = "SIGN";
   String ENC = "ENC";
   String EC = "EC";
   String SM3 = "SM3";
   String SM1 = "SM1";
   String SM4 = "SM4";
   String RC4 = "RC4";
   String SHA256 = "SHA256";
   String SHA1 = "SHA1";
   String INFOSEC = "INFOSEC";
   String SHA1withRSA = "SHA1withRSA";
   String SHA256withRSA = "SHA256withRSA";
   String SM3withSM2 = "SM3withSM2";
   String MD5withRSA = "MD5withRSA";
   String SM3withSM2Oid = "1.2.156.10197.1.501";
   String SM2PublickOid = "1.2.840.10045.2.1";
   String SM2PublicSpecOid = "1.2.156.10197.1.301";
   String SM1Oid = "1.2.156.10197.1.102";
   String SM3Oid = "1.2.156.10197.401";

   void init();

   void release();

   void setSupportedSymAlg_GM(String[] var1);

   String[] getSupportedSymAlg_GM();

   byte[] sign(String var1, int var2, char[] var3, byte[] var4, String var5, String var6);

   boolean verify(byte[] var1, byte[] var2, PublicKey var3, String var4, String var5);

   byte[] genKEK(int var1, String var2, int var3, char[] var4, String var5);

   byte[][] genEncKeyPair(byte[] var1, String var2, int var3, char[] var4, String var5, String var6, String var7, int var8);

   WrapedEncKeyByUser wrapPrivKeyByUserPubKey(byte[] var1, byte[] var2, String var3, String var4, String var5, char[] var6, PublicKey var7, String var8);

   byte[] reWrapPrivKeyByKek(String var1, byte[] var2, byte[] var3, byte[] var4, String var5, int var6, String var7, char[] var8);

   PublicKey exportPublicKey(String var1, String var2, String var3, int var4, char[] var5);
}
